/*
 * Copyright (c) 2006 Frederic Camps
 * Copyright (c) 2006-2009 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include <stdio.h>
#include <stdlib.h>

#include "serial.h"
#include "horodatage.h"

/*!
  @brief Affiche le contenu d'une structure de donnes sous forme ASCII

  @param struct timeval timev : affiche le contenu
*/
void
printHorodatage(struct timeval *timev)
{
	struct tm* ptm;
	char time_string[40];
	long milliseconds;

	ptm = localtime (&(timev->tv_sec));

	/* Compute milliseconds from microseconds. */
	milliseconds = timev->tv_usec / 1000;

	/* Format the date and time, down to a single second. */
	strftime (time_string, sizeof (time_string), "%Y-%m-%d %H:%M:%S", ptm);

	/* Print the formatted time, in seconds, followed by a decimal point
	   and the milliseconds. */
	printf ("\n************> %s.%03ld <************\n",
	    time_string, milliseconds);
}
