/*
 * Copyright (c) 2003-2009 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef _SERIAL_H
#define _SERIAL_H

#define TAILLE_BUFFER  7168
#define TAILLE_BUFFER_SERIE 512


/* prototypes */
int openSerial(const char *, int , int , int );
int readSerial(int, int *nbTrame);
int writeSerial(int, char []);
void stockBinaryTrame(unsigned char* ,  int );
void stockAsciiLog(unsigned char *, int );
int isTrameIsBuffered();
void unStackBuffer(int, int);
int clearBufferSerie(int);
void stockArrivalTime(int);
void unStackArrivalTime(int,  int );
void DEBUG_FUNCTION( unsigned char, unsigned short, int, int);
int checkGPS(int);

typedef unsigned char uchar;

/* Structure qui contiendra l'etat de chacun des bit qui compose un char*/
/* cette structure est utilise pour dterminer le type d'une trame binaire */
typedef struct {
     uchar b0:1;
     uchar b1:1;
     uchar b2:1;
     uchar b3:1;
     uchar b4:1;
     uchar b5:1;
     uchar b6:1;
     uchar b7:1;
} octet;

/* union qui me permet de superposer les variable 'valeur' et 'etat'*/
union _mot {
     char valeur;
     octet etat;
} mot;


// Indique le nombre de trame dans le buffer de sortie
// pour l'utilisateur
int NB_TRAME_BUFFERED;

#endif
